Index: include/avr/iomxx0_1.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/iomxx0_1.h,v
retrieving revision 1.12
diff -u -r1.12 iomxx0_1.h
--- include/avr/iomxx0_1.h	12 Dec 2007 14:00:49 -0000	1.12
+++ include/avr/iomxx0_1.h	26 Mar 2009 20:10:34 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2005 Anatoly Sokolov 
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -1300,211 +1301,261 @@
 /* Interrupt vectors */
 /* Vector 0 is the reset vector */
 /* External Interrupt Request 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* External Interrupt Request 1 */
+#define INT1_num 			2
 #define INT1_vect			_VECTOR(2)
 #define SIG_INTERRUPT1			_VECTOR(2)
 
 /* External Interrupt Request 2 */
+#define INT2_num 			3
 #define INT2_vect			_VECTOR(3)
 #define SIG_INTERRUPT2			_VECTOR(3)
 
 /* External Interrupt Request 3 */
+#define INT3_num 			4
 #define INT3_vect			_VECTOR(4)
 #define SIG_INTERRUPT3			_VECTOR(4)
 
 /* External Interrupt Request 4 */
+#define INT4_num 			5
 #define INT4_vect			_VECTOR(5)
 #define SIG_INTERRUPT4			_VECTOR(5)
 
 /* External Interrupt Request 5 */
+#define INT5_num 			6
 #define INT5_vect			_VECTOR(6)
 #define SIG_INTERRUPT5			_VECTOR(6)
 
 /* External Interrupt Request 6 */
+#define INT6_num 			7
 #define INT6_vect			_VECTOR(7)
 #define SIG_INTERRUPT6			_VECTOR(7)
 
 /* External Interrupt Request 7 */
+#define INT7_num 			8
 #define INT7_vect			_VECTOR(8)
 #define SIG_INTERRUPT7			_VECTOR(8)
 
 /* Pin Change Interrupt Request 0 */
+#define PCINT0_num 			9
 #define PCINT0_vect			_VECTOR(9)
 #define SIG_PIN_CHANGE0			_VECTOR(9)
 
 /* Pin Change Interrupt Request 1 */
+#define PCINT1_num 			10
 #define PCINT1_vect			_VECTOR(10)
 #define SIG_PIN_CHANGE1			_VECTOR(10)
 
 #if defined(__ATmegaxx0__)
 /* Pin Change Interrupt Request 2 */
+#define PCINT2_num 			11
 #define PCINT2_vect			_VECTOR(11)
 #define SIG_PIN_CHANGE2			_VECTOR(11)
 
 #endif /* __ATmegaxx0__ */
 
 /* Watchdog Time-out Interrupt */
+#define WDT_num 			12
 #define WDT_vect			_VECTOR(12)
 #define SIG_WATCHDOG_TIMEOUT		_VECTOR(12)
 
 /* Timer/Counter2 Compare Match A */
+#define TIMER2_COMPA_num 		13
 #define TIMER2_COMPA_vect		_VECTOR(13)
 #define SIG_OUTPUT_COMPARE2A		_VECTOR(13)
 
 /* Timer/Counter2 Compare Match B */
+#define TIMER2_COMPB_num 		14
 #define TIMER2_COMPB_vect		_VECTOR(14)
 #define SIG_OUTPUT_COMPARE2B		_VECTOR(14)
 
 /* Timer/Counter2 Overflow */
+#define TIMER2_OVF_num 			15
 #define TIMER2_OVF_vect			_VECTOR(15)
 #define SIG_OVERFLOW2			_VECTOR(15)
 
 /* Timer/Counter1 Capture Event */
+#define TIMER1_CAPT_num 		16
 #define TIMER1_CAPT_vect		_VECTOR(16)
 #define SIG_INPUT_CAPTURE1		_VECTOR(16)
 
 /* Timer/Counter1 Compare Match A */
+#define TIMER1_COMPA_num 		17
 #define TIMER1_COMPA_vect		_VECTOR(17)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(17)
 
 /* Timer/Counter1 Compare Match B */
+#define TIMER1_COMPB_num 		18
 #define TIMER1_COMPB_vect		_VECTOR(18)
 #define SIG_OUTPUT_COMPARE1B		_VECTOR(18)
 
 /* Timer/Counter1 Compare Match C */
+#define TIMER1_COMPC_num 		19
 #define TIMER1_COMPC_vect		_VECTOR(19)
 #define SIG_OUTPUT_COMPARE1C		_VECTOR(19)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num 			20
 #define TIMER1_OVF_vect			_VECTOR(20)
 #define SIG_OVERFLOW1			_VECTOR(20)
 
 /* Timer/Counter0 Compare Match A */
+#define TIMER0_COMPA_num 		21
 #define TIMER0_COMPA_vect		_VECTOR(21)
 #define SIG_OUTPUT_COMPARE0A		_VECTOR(21)
 
 /* Timer/Counter0 Compare Match B */
+#define TIMER0_COMPB_num 		22
 #define TIMER0_COMPB_vect		_VECTOR(22)
 #define SIG_OUTPUT_COMPARE0B		_VECTOR(22)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			23
 #define TIMER0_OVF_vect			_VECTOR(23)
 #define SIG_OVERFLOW0			_VECTOR(23)
 
 /* SPI Serial Transfer Complete */
+#define SPI_STC_num 			24
 #define SPI_STC_vect			_VECTOR(24)
 #define SIG_SPI				_VECTOR(24)
 
 /* USART0, Rx Complete */
+#define USART0_RX_num 			25
 #define USART0_RX_vect			_VECTOR(25)
 #define SIG_USART0_RECV			_VECTOR(25)
 
 /* USART0 Data register Empty */
+#define USART0_UDRE_num 		26
 #define USART0_UDRE_vect		_VECTOR(26)
 #define SIG_USART0_DATA			_VECTOR(26)
 
 /* USART0, Tx Complete */
+#define USART0_TX_num 			27
 #define USART0_TX_vect			_VECTOR(27)
 #define SIG_USART0_TRANS		_VECTOR(27)
 
 /* Analog Comparator */
+#define ANALOG_COMP_num 		28
 #define ANALOG_COMP_vect		_VECTOR(28)
 #define SIG_COMPARATOR			_VECTOR(28)
 
 /* ADC Conversion Complete */
+#define ADC_num 			29
 #define ADC_vect			_VECTOR(29)
 #define SIG_ADC				_VECTOR(29)
 
 /* EEPROM Ready */
+#define EE_READY_num 			30
 #define EE_READY_vect			_VECTOR(30)
 #define SIG_EEPROM_READY		_VECTOR(30)
 
 /* Timer/Counter3 Capture Event */
+#define TIMER3_CAPT_num 		31
 #define TIMER3_CAPT_vect		_VECTOR(31)
 #define SIG_INPUT_CAPTURE3		_VECTOR(31)
 
 /* Timer/Counter3 Compare Match A */
+#define TIMER3_COMPA_num 		32
 #define TIMER3_COMPA_vect		_VECTOR(32)
 #define SIG_OUTPUT_COMPARE3A		_VECTOR(32)
 
 /* Timer/Counter3 Compare Match B */
+#define TIMER3_COMPB_num 		33
 #define TIMER3_COMPB_vect		_VECTOR(33)
 #define SIG_OUTPUT_COMPARE3B		_VECTOR(33)
 
 /* Timer/Counter3 Compare Match C */
+#define TIMER3_COMPC_num 		34
 #define TIMER3_COMPC_vect		_VECTOR(34)
 #define SIG_OUTPUT_COMPARE3C		_VECTOR(34)
 
 /* Timer/Counter3 Overflow */
+#define TIMER3_OVF_num 			35
 #define TIMER3_OVF_vect			_VECTOR(35)
 #define SIG_OVERFLOW3			_VECTOR(35)
 
 /* USART1, Rx Complete */
+#define USART1_RX_num 			36
 #define USART1_RX_vect			_VECTOR(36)
 #define SIG_USART1_RECV			_VECTOR(36)
 
 /* USART1 Data register Empty */
+#define USART1_UDRE_num 		37
 #define USART1_UDRE_vect		_VECTOR(37)
 #define SIG_USART1_DATA			_VECTOR(37)
 
 /* USART1, Tx Complete */
+#define USART1_TX_num 			38
 #define USART1_TX_vect			_VECTOR(38)
 #define SIG_USART1_TRANS		_VECTOR(38)
 
 /* 2-wire Serial Interface */
+#define TWI_num 			39
 #define TWI_vect			_VECTOR(39)
 #define SIG_2WIRE_SERIAL		_VECTOR(39)
 
 /* Store Program Memory Read */
+#define SPM_READY_num 			40
 #define SPM_READY_vect			_VECTOR(40)
 #define SIG_SPM_READY			_VECTOR(40)
 
 #if defined(__ATmegaxx0__)
 /* Timer/Counter4 Capture Event */
+#define TIMER4_CAPT_num 		41
 #define TIMER4_CAPT_vect		_VECTOR(41)
 #define SIG_INPUT_CAPTURE4		_VECTOR(41)
 
 #endif /* __ATmegaxx0__ */
 
 /* Timer/Counter4 Compare Match A */
+#define TIMER4_COMPA_num 		42
 #define TIMER4_COMPA_vect		_VECTOR(42)
 #define SIG_OUTPUT_COMPARE4A		_VECTOR(42)
 
 /* Timer/Counter4 Compare Match B */
+#define TIMER4_COMPB_num 		43
 #define TIMER4_COMPB_vect		_VECTOR(43)
 #define SIG_OUTPUT_COMPARE4B		_VECTOR(43)
 
 /* Timer/Counter4 Compare Match C */
+#define TIMER4_COMPC_num 		44
 #define TIMER4_COMPC_vect		_VECTOR(44)
 #define SIG_OUTPUT_COMPARE4C		_VECTOR(44)
 
 /* Timer/Counter4 Overflow */
+#define TIMER4_OVF_num 			45
 #define TIMER4_OVF_vect			_VECTOR(45)
 #define SIG_OVERFLOW4			_VECTOR(45)
 
 #if defined(__ATmegaxx0__)
 /* Timer/Counter5 Capture Event */
+#define TIMER5_CAPT_num 		46
 #define TIMER5_CAPT_vect		_VECTOR(46)
 #define SIG_INPUT_CAPTURE5		_VECTOR(46)
 
 #endif /* __ATmegaxx0__ */
 
 /* Timer/Counter5 Compare Match A */
+#define TIMER5_COMPA_num 		47
 #define TIMER5_COMPA_vect		_VECTOR(47)
 #define SIG_OUTPUT_COMPARE5A		_VECTOR(47)
 
 /* Timer/Counter5 Compare Match B */
+#define TIMER5_COMPB_num 		48
 #define TIMER5_COMPB_vect		_VECTOR(48)
 #define SIG_OUTPUT_COMPARE5B		_VECTOR(48)
 
 /* Timer/Counter5 Compare Match C */
+#define TIMER5_COMPC_num 		49
 #define TIMER5_COMPC_vect		_VECTOR(49)
 #define SIG_OUTPUT_COMPARE5C		_VECTOR(49)
 
 /* Timer/Counter5 Overflow */
+#define TIMER5_OVF_num 			50
 #define TIMER5_OVF_vect			_VECTOR(50)
 #define SIG_OVERFLOW5			_VECTOR(50)
 
@@ -1515,26 +1566,32 @@
 #else
 
 /* USART2, Rx Complete */
+#define USART2_RX_num 			51
 #define USART2_RX_vect			_VECTOR(51)
 #define SIG_USART2_RECV			_VECTOR(51)
 
 /* USART2 Data register Empty */
+#define USART2_UDRE_num 		52
 #define USART2_UDRE_vect		_VECTOR(52)
 #define SIG_USART2_DATA			_VECTOR(52)
 
 /* USART2, Tx Complete */
+#define USART2_TX_num 			53
 #define USART2_TX_vect			_VECTOR(53)
 #define SIG_USART2_TRANS		_VECTOR(53)
 
 /* USART3, Rx Complete */
+#define USART3_RX_num 			54
 #define USART3_RX_vect			_VECTOR(54)
 #define SIG_USART3_RECV			_VECTOR(54)
 
 /* USART3 Data register Empty */
+#define USART3_UDRE_num 		55
 #define USART3_UDRE_vect		_VECTOR(55)
 #define SIG_USART3_DATA			_VECTOR(55)
 
 /* USART3, Tx Complete */
+#define USART3_TX_num 			56
 #define USART3_TX_vect			_VECTOR(56)
 #define SIG_USART3_TRANS		_VECTOR(56)
 
@@ -1550,4 +1607,571 @@
 # undef __ATmegaxx1__
 #endif
 
+/* Device Pin Definitions */
+#define DDR_AD0  	DDRA
+#define PORT_AD0 	PORTA
+#define PIN_AD0  	PINA
+#define AD0_IDX  	0
+
+#define DDR_AD1  	DDRA
+#define PORT_AD1 	PORTA
+#define PIN_AD1  	PINA
+#define AD1_IDX  	1
+
+#define DDR_AD2  	DDRA
+#define PORT_AD2 	PORTA
+#define PIN_AD2  	PINA
+#define AD2_IDX  	2
+
+#define DDR_AD3  	DDRA
+#define PORT_AD3 	PORTA
+#define PIN_AD3  	PINA
+#define AD3_IDX  	3
+
+#define DDR_AD4  	DDRA
+#define PORT_AD4 	PORTA
+#define PIN_AD4  	PINA
+#define AD4_IDX  	4
+
+#define DDR_AD5  	DDRA
+#define PORT_AD5 	PORTA
+#define PIN_AD5  	PINA
+#define AD5_IDX  	5
+
+#define DDR_AD6  	DDRA
+#define PORT_AD6 	PORTA
+#define PIN_AD6  	PINA
+#define AD6_IDX  	6
+
+#define DDR_AD7  	DDRA
+#define PORT_AD7 	PORTA
+#define PIN_AD7  	PINA
+#define AD7_IDX  	7
+
+#define DDR_SS  	DDRB
+#define PORT_SS 	PORTB
+#define PIN_SS  	PINB
+#define SS_IDX  	0
+
+#define DDR_PCINT0  	DDRB
+#define PORT_PCINT0 	PORTB
+#define PIN_PCINT0  	PINB
+#define PCINT0_IDX  	0
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	1
+
+#define DDR_PCINT1  	DDRB
+#define PORT_PCINT1 	PORTB
+#define PIN_PCINT1  	PINB
+#define PCINT1_IDX  	1
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	2
+
+#define DDR_PCINT2  	DDRB
+#define PORT_PCINT2 	PORTB
+#define PIN_PCINT2  	PINB
+#define PCINT2_IDX  	2
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	3
+
+#define DDR_PCINT3  	DDRB
+#define PORT_PCINT3 	PORTB
+#define PIN_PCINT3  	PINB
+#define PCINT3_IDX  	3
+
+#define DDR_OC0A  	DDRB
+#define PORT_OC0A 	PORTB
+#define PIN_OC0A  	PINB
+#define OC0A_IDX  	4
+
+#define DDR_PCINT4  	DDRB
+#define PORT_PCINT4 	PORTB
+#define PIN_PCINT4  	PINB
+#define PCINT4_IDX  	4
+
+#define DDR_OC1A  	DDRB
+#define PORT_OC1A 	PORTB
+#define PIN_OC1A  	PINB
+#define OC1A_IDX  	5
+
+#define DDR_PCINT5  	DDRB
+#define PORT_PCINT5 	PORTB
+#define PIN_PCINT5  	PINB
+#define PCINT5_IDX  	5
+
+#define DDR_OC1B  	DDRB
+#define PORT_OC1B 	PORTB
+#define PIN_OC1B  	PINB
+#define OC1B_IDX  	6
+
+#define DDR_PCINT6  	DDRB
+#define PORT_PCINT6 	PORTB
+#define PIN_PCINT6  	PINB
+#define PCINT6_IDX  	6
+
+#define DDR_OC0A  	DDRB
+#define PORT_OC0A 	PORTB
+#define PIN_OC0A  	PINB
+#define OC0A_IDX  	7
+
+#define DDR_OC1C  	DDRB
+#define PORT_OC1C 	PORTB
+#define PIN_OC1C  	PINB
+#define OC1C_IDX  	7
+
+#define DDR_PCINT7  	DDRB
+#define PORT_PCINT7 	PORTB
+#define PIN_PCINT7  	PINB
+#define PCINT7_IDX  	7
+
+#define DDR_A8  	DDRC
+#define PORT_A8 	PORTC
+#define PIN_A8  	PINC
+#define A8_IDX  	0
+
+#define DDR_A9  	DDRC
+#define PORT_A9 	PORTC
+#define PIN_A9  	PINC
+#define A9_IDX  	1
+
+#define DDR_A10  	DDRC
+#define PORT_A10 	PORTC
+#define PIN_A10  	PINC
+#define A10_IDX  	2
+
+#define DDR_A11  	DDRC
+#define PORT_A11 	PORTC
+#define PIN_A11  	PINC
+#define A11_IDX  	3
+
+#define DDR_A12  	DDRC
+#define PORT_A12 	PORTC
+#define PIN_A12  	PINC
+#define A12_IDX  	4
+
+#define DDR_A13  	DDRC
+#define PORT_A13 	PORTC
+#define PIN_A13  	PINC
+#define A13_IDX  	5
+
+#define DDR_A14  	DDRC
+#define PORT_A14 	PORTC
+#define PIN_A14  	PINC
+#define A14_IDX  	6
+
+#define DDR_A15  	DDRC
+#define PORT_A15 	PORTC
+#define PIN_A15  	PINC
+#define A15_IDX  	7
+
+#define DDR_SCL  	DDRD
+#define PORT_SCL 	PORTD
+#define PIN_SCL  	PIND
+#define SCL_IDX  	0
+
+#define DDR_INT0  	DDRD
+#define PORT_INT0 	PORTD
+#define PIN_INT0  	PIND
+#define INT0_IDX  	0
+
+#define DDR_SDA  	DDRD
+#define PORT_SDA 	PORTD
+#define PIN_SDA  	PIND
+#define SDA_IDX  	1
+
+#define DDR_INT1  	DDRD
+#define PORT_INT1 	PORTD
+#define PIN_INT1  	PIND
+#define INT1_IDX  	1
+
+#define DDR_RXD1  	DDRD
+#define PORT_RXD1 	PORTD
+#define PIN_RXD1  	PIND
+#define RXD1_IDX  	2
+
+#define DDR_INT2  	DDRD
+#define PORT_INT2 	PORTD
+#define PIN_INT2  	PIND
+#define INT2_IDX  	2
+
+#define DDR_TXD1  	DDRD
+#define PORT_TXD1 	PORTD
+#define PIN_TXD1  	PIND
+#define TXD1_IDX  	3
+
+#define DDR_INT3  	DDRD
+#define PORT_INT3 	PORTD
+#define PIN_INT3  	PIND
+#define INT3_IDX  	3
+
+#define DDR_ICP1  	DDRD
+#define PORT_ICP1 	PORTD
+#define PIN_ICP1  	PIND
+#define ICP1_IDX  	4
+
+#define DDR_XCK1  	DDRD
+#define PORT_XCK1 	PORTD
+#define PIN_XCK1  	PIND
+#define XCK1_IDX  	5
+
+#define DDR_T1  	DDRD
+#define PORT_T1 	PORTD
+#define PIN_T1  	PIND
+#define T1_IDX  	6
+
+#define DDR_T0  	DDRD
+#define PORT_T0 	PORTD
+#define PIN_T0  	PIND
+#define T0_IDX  	7
+
+#define DDR_RXD  	DDRE
+#define PORT_RXD 	PORTE
+#define PIN_RXD  	PINE
+#define RXD_IDX  	0
+
+#define DDR_PCINT8  	DDRE
+#define PORT_PCINT8 	PORTE
+#define PIN_PCINT8  	PINE
+#define PCINT8_IDX  	0
+
+#define DDR_TXD0  	DDRE
+#define PORT_TXD0 	PORTE
+#define PIN_TXD0  	PINE
+#define TXD0_IDX  	1
+
+#define DDR_XCK  	DDRE
+#define PORT_XCK 	PORTE
+#define PIN_XCK  	PINE
+#define XCK_IDX  	2
+
+#define DDR_AIN0  	DDRE
+#define PORT_AIN0 	PORTE
+#define PIN_AIN0  	PINE
+#define AIN0_IDX  	2
+
+#define DDR_OC3A  	DDRE
+#define PORT_OC3A 	PORTE
+#define PIN_OC3A  	PINE
+#define OC3A_IDX  	3
+
+#define DDR_AIN1  	DDRE
+#define PORT_AIN1 	PORTE
+#define PIN_AIN1  	PINE
+#define AIN1_IDX  	3
+
+#define DDR_OC3B  	DDRE
+#define PORT_OC3B 	PORTE
+#define PIN_OC3B  	PINE
+#define OC3B_IDX  	4
+
+#define DDR_INT4  	DDRE
+#define PORT_INT4 	PORTE
+#define PIN_INT4  	PINE
+#define INT4_IDX  	4
+
+#define DDR_OC3C  	DDRE
+#define PORT_OC3C 	PORTE
+#define PIN_OC3C  	PINE
+#define OC3C_IDX  	5
+
+#define DDR_INT5  	DDRE
+#define PORT_INT5 	PORTE
+#define PIN_INT5  	PINE
+#define INT5_IDX  	5
+
+#define DDR_T3  	DDRE
+#define PORT_T3 	PORTE
+#define PIN_T3  	PINE
+#define T3_IDX  	6
+
+#define DDR_INT6  	DDRE
+#define PORT_INT6 	PORTE
+#define PIN_INT6  	PINE
+#define INT6_IDX  	6
+
+#define DDR_CLKO  	DDRE
+#define PORT_CLKO 	PORTE
+#define PIN_CLKO  	PINE
+#define CLKO_IDX  	7
+
+#define DDR_ICP3  	DDRE
+#define PORT_ICP3 	PORTE
+#define PIN_ICP3  	PINE
+#define ICP3_IDX  	7
+
+#define DDR_INT7  	DDRE
+#define PORT_INT7 	PORTE
+#define PIN_INT7  	PINE
+#define INT7_IDX  	7
+
+#define DDR_ADC0  	DDRF
+#define PORT_ADC0 	PORTF
+#define PIN_ADC0  	PINF
+#define ADC0_IDX  	0
+
+#define DDR_ADC1  	DDRF
+#define PORT_ADC1 	PORTF
+#define PIN_ADC1  	PINF
+#define ADC1_IDX  	1
+
+#define DDR_ADC2  	DDRF
+#define PORT_ADC2 	PORTF
+#define PIN_ADC2  	PINF
+#define ADC2_IDX  	2
+
+#define DDR_ADC3  	DDRF
+#define PORT_ADC3 	PORTF
+#define PIN_ADC3  	PINF
+#define ADC3_IDX  	3
+
+#define DDR_ADC4  	DDRF
+#define PORT_ADC4 	PORTF
+#define PIN_ADC4  	PINF
+#define ADC4_IDX  	4
+
+#define DDR_ADC5  	DDRF
+#define PORT_ADC5 	PORTF
+#define PIN_ADC5  	PINF
+#define ADC5_IDX  	5
+
+#define DDR_ADC6  	DDRF
+#define PORT_ADC6 	PORTF
+#define PIN_ADC6  	PINF
+#define ADC6_IDX  	6
+
+#define DDR_ADC7  	DDRF
+#define PORT_ADC7 	PORTF
+#define PIN_ADC7  	PINF
+#define ADC7_IDX  	7
+
+#define DDR_WR  	DDRG
+#define PORT_WR 	PORTG
+#define PIN_WR  	PING
+#define WR_IDX  	0
+
+#define DDR_RD  	DDRG
+#define PORT_RD 	PORTG
+#define PIN_RD  	PING
+#define RD_IDX  	1
+
+#define DDR_ALE  	DDRG
+#define PORT_ALE 	PORTG
+#define PIN_ALE  	PING
+#define ALE_IDX  	2
+
+#define DDR_OC0B  	DDRG
+#define PORT_OC0B 	PORTG
+#define PIN_OC0B  	PING
+#define OC0B_IDX  	5
+
+#define DDR_RXD2  	DDRH
+#define PORT_RXD2 	PORTH
+#define PIN_RXD2  	PINH
+#define RXD2_IDX  	0
+
+#define DDR_TXD2  	DDRH
+#define PORT_TXD2 	PORTH
+#define PIN_TXD2  	PINH
+#define TXD2_IDX  	1
+
+#define DDR_XCK2  	DDRH
+#define PORT_XCK2 	PORTH
+#define PIN_XCK2  	PINH
+#define XCK2_IDX  	2
+
+#define DDR_OC4A  	DDRH
+#define PORT_OC4A 	PORTH
+#define PIN_OC4A  	PINH
+#define OC4A_IDX  	3
+
+#define DDR_OC4B  	DDRH
+#define PORT_OC4B 	PORTH
+#define PIN_OC4B  	PINH
+#define OC4B_IDX  	4
+
+#define DDR_OC4C  	DDRH
+#define PORT_OC4C 	PORTH
+#define PIN_OC4C  	PINH
+#define OC4C_IDX  	5
+
+#define DDR_OC2B  	DDRH
+#define PORT_OC2B 	PORTH
+#define PIN_OC2B  	PINH
+#define OC2B_IDX  	6
+
+#define DDR_T4  	DDRH
+#define PORT_T4 	PORTH
+#define PIN_T4  	PINH
+#define T4_IDX  	7
+
+#define DDR_RXD3  	DDRJ
+#define PORT_RXD3 	PORTJ
+#define PIN_RXD3  	PINJ
+#define RXD3_IDX  	0
+
+#define DDR_PCINT9  	DDRJ
+#define PORT_PCINT9 	PORTJ
+#define PIN_PCINT9  	PINJ
+#define PCINT9_IDX  	0
+
+#define DDR_TXD3  	DDRJ
+#define PORT_TXD3 	PORTJ
+#define PIN_TXD3  	PINJ
+#define TXD3_IDX  	1
+
+#define DDR_PCINT10  	DDRJ
+#define PORT_PCINT10 	PORTJ
+#define PIN_PCINT10  	PINJ
+#define PCINT10_IDX  	1
+
+#define DDR_XCK3  	DDRJ
+#define PORT_XCK3 	PORTJ
+#define PIN_XCK3  	PINJ
+#define XCK3_IDX  	2
+
+#define DDR_PCINT11  	DDRJ
+#define PORT_PCINT11 	PORTJ
+#define PIN_PCINT11  	PINJ
+#define PCINT11_IDX  	2
+
+#define DDR_PCINT12  	DDRJ
+#define PORT_PCINT12 	PORTJ
+#define PIN_PCINT12  	PINJ
+#define PCINT12_IDX  	3
+
+#define DDR_PCINT13  	DDRJ
+#define PORT_PCINT13 	PORTJ
+#define PIN_PCINT13  	PINJ
+#define PCINT13_IDX  	4
+
+#define DDR_PCINT14  	DDRJ
+#define PORT_PCINT14 	PORTJ
+#define PIN_PCINT14  	PINJ
+#define PCINT14_IDX  	5
+
+#define DDR_PCINT15  	DDRJ
+#define PORT_PCINT15 	PORTJ
+#define PIN_PCINT15  	PINJ
+#define PCINT15_IDX  	6
+
+#define DDR_ADC8  	DDRK
+#define PORT_ADC8 	PORTK
+#define PIN_ADC8  	PINK
+#define ADC8_IDX  	0
+
+#define DDR_PCINT16  	DDRK
+#define PORT_PCINT16 	PORTK
+#define PIN_PCINT16  	PINK
+#define PCINT16_IDX  	0
+
+#define DDR_ADC9  	DDRK
+#define PORT_ADC9 	PORTK
+#define PIN_ADC9  	PINK
+#define ADC9_IDX  	1
+
+#define DDR_PCINT17  	DDRK
+#define PORT_PCINT17 	PORTK
+#define PIN_PCINT17  	PINK
+#define PCINT17_IDX  	1
+
+#define DDR_ADC10  	DDRK
+#define PORT_ADC10 	PORTK
+#define PIN_ADC10  	PINK
+#define ADC10_IDX  	2
+
+#define DDR_PCINT18  	DDRK
+#define PORT_PCINT18 	PORTK
+#define PIN_PCINT18  	PINK
+#define PCINT18_IDX  	2
+
+#define DDR_ADC11  	DDRK
+#define PORT_ADC11 	PORTK
+#define PIN_ADC11  	PINK
+#define ADC11_IDX  	3
+
+#define DDR_PCINT19  	DDRK
+#define PORT_PCINT19 	PORTK
+#define PIN_PCINT19  	PINK
+#define PCINT19_IDX  	3
+
+#define DDR_ADC12  	DDRK
+#define PORT_ADC12 	PORTK
+#define PIN_ADC12  	PINK
+#define ADC12_IDX  	4
+
+#define DDR_PCINT20  	DDRK
+#define PORT_PCINT20 	PORTK
+#define PIN_PCINT20  	PINK
+#define PCINT20_IDX  	4
+
+#define DDR_ADC13  	DDRK
+#define PORT_ADC13 	PORTK
+#define PIN_ADC13  	PINK
+#define ADC13_IDX  	5
+
+#define DDR_PCINT21  	DDRK
+#define PORT_PCINT21 	PORTK
+#define PIN_PCINT21  	PINK
+#define PCINT21_IDX  	5
+
+#define DDR_ADC14  	DDRK
+#define PORT_ADC14 	PORTK
+#define PIN_ADC14  	PINK
+#define ADC14_IDX  	6
+
+#define DDR_PCINT22  	DDRK
+#define PORT_PCINT22 	PORTK
+#define PIN_PCINT22  	PINK
+#define PCINT22_IDX  	6
+
+#define DDR_ADC15  	DDRK
+#define PORT_ADC15 	PORTK
+#define PIN_ADC15  	PINK
+#define ADC15_IDX  	7
+
+#define DDR_PCINT23  	DDRK
+#define PORT_PCINT23 	PORTK
+#define PIN_PCINT23  	PINK
+#define PCINT23_IDX  	7
+
+#define DDR_ICP4  	DDRL
+#define PORT_ICP4 	PORTL
+#define PIN_ICP4  	PINL
+#define ICP4_IDX  	0
+
+#define DDR_ICP5  	DDRL
+#define PORT_ICP5 	PORTL
+#define PIN_ICP5  	PINL
+#define ICP5_IDX  	1
+
+#define DDR_T5  	DDRL
+#define PORT_T5 	PORTL
+#define PIN_T5  	PINL
+#define T5_IDX  	2
+
+#define DDR_OC5A  	DDRL
+#define PORT_OC5A 	PORTL
+#define PIN_OC5A  	PINL
+#define OC5A_IDX  	3
+
+#define DDR_OC5B  	DDRL
+#define PORT_OC5B 	PORTL
+#define PIN_OC5B  	PINL
+#define OC5B_IDX  	4
+
+#define DDR_OC5C  	DDRL
+#define PORT_OC5C 	PORTL
+#define PIN_OC5C  	PINL
+#define OC5C_IDX  	5
+
+
 #endif /* _AVR_IOMXX0_1_H_ */
Index: include/avr/io86r401.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/io86r401.h,v
retrieving revision 1.9
diff -u -r1.9 io86r401.h
--- include/avr/io86r401.h	11 Feb 2009 17:53:34 -0000	1.9
+++ include/avr/io86r401.h	26 Mar 2009 20:10:21 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2002, Colin O'Flynn
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -117,10 +118,12 @@
 /* Interrupt vectors */
 
 /* Transmission Done, Bit Timer Flag 2 Interrupt */
+#define TXDONE_num 			1
 #define TXDONE_vect			_VECTOR(1)
 #define SIG_TXDONE			_VECTOR(1)
 
 /* Transmit Buffer Empty, Bit Itmer Flag 0 Interrupt */
+#define TXEMPTY_num 			2
 #define TXEMPTY_vect			_VECTOR(2)
 #define SIG_TXBE			_VECTOR(2)
 
@@ -305,4 +308,6 @@
 #define SIGNATURE_2 0x81
 
 
+/* Device Pin Definitions */
+
 #endif  /* _AVR_IO86RF401_H_ */
Index: include/avr/io4414.h
===================================================================
RCS file: /sources/avr-libc/avr-libc/include/avr/io4414.h,v
retrieving revision 1.11
diff -u -r1.11 io4414.h
--- include/avr/io4414.h	13 Aug 2008 23:29:49 -0000	1.11
+++ include/avr/io4414.h	26 Mar 2009 20:10:20 -0000
@@ -1,4 +1,5 @@
 /* Copyright (c) 2002, Marek Michalkiewicz
+   Copyright (c) 2009, Frédéric Nadeau
    All rights reserved.
 
    Redistribution and use in source and binary forms, with or without
@@ -176,50 +177,62 @@
 /* Interrupt vectors */
 
 /* External Interrupt Request 0 */
+#define INT0_num 			1
 #define INT0_vect			_VECTOR(1)
 #define SIG_INTERRUPT0			_VECTOR(1)
 
 /* External Interrupt Request 1 */
+#define INT1_num 			2
 #define INT1_vect			_VECTOR(2)
 #define SIG_INTERRUPT1			_VECTOR(2)
 
 /* Timer/Counter Capture Event */
+#define TIMER1_CAPT_num 		3
 #define TIMER1_CAPT_vect		_VECTOR(3)
 #define SIG_INPUT_CAPTURE1		_VECTOR(3)
 
 /* Timer/Counter1 Compare Match A */
+#define TIMER1_COMPA_num 		4
 #define TIMER1_COMPA_vect		_VECTOR(4)
 #define SIG_OUTPUT_COMPARE1A		_VECTOR(4)
 
 /* Timer/Counter1 Compare MatchB */
+#define TIMER1_COMPB_num 		5
 #define TIMER1_COMPB_vect		_VECTOR(5)
 #define SIG_OUTPUT_COMPARE1B		_VECTOR(5)
 
 /* Timer/Counter1 Overflow */
+#define TIMER1_OVF_num 			6
 #define TIMER1_OVF_vect			_VECTOR(6)
 #define SIG_OVERFLOW1			_VECTOR(6)
 
 /* Timer/Counter0 Overflow */
+#define TIMER0_OVF_num 			7
 #define TIMER0_OVF_vect			_VECTOR(7)
 #define SIG_OVERFLOW0			_VECTOR(7)
 
 /* Serial Transfer Complete */
+#define SPI_STC_num 			8
 #define SPI_STC_vect			_VECTOR(8)
 #define SIG_SPI				_VECTOR(8)
 
 /* UART, Rx Complete */
+#define UART_RX_num 			9
 #define UART_RX_vect			_VECTOR(9)
 #define SIG_UART_RECV			_VECTOR(9)
 
 /* UART Data Register Empty */
+#define UART_UDRE_num 			10
 #define UART_UDRE_vect			_VECTOR(10)
 #define SIG_UART_DATA			_VECTOR(10)
 
 /* UART, Tx Complete */
+#define UART_TX_num 			11
 #define UART_TX_vect			_VECTOR(11)
 #define SIG_UART_TRANS			_VECTOR(11)
 
 /* Analog Comparator */
+#define ANA_COMP_num 			12
 #define ANA_COMP_vect			_VECTOR(12)
 #define SIG_COMPARATOR			_VECTOR(12)
 
@@ -482,4 +495,161 @@
 #define SIGNATURE_2 0x01
 
 
+/* Device Pin Definitions */
+#define DDR_AD0  	DDRA
+#define PORT_AD0 	PORTA
+#define PIN_AD0  	PINA
+#define AD0_IDX  	0
+
+#define DDR_AD1  	DDRA
+#define PORT_AD1 	PORTA
+#define PIN_AD1  	PINA
+#define AD1_IDX  	1
+
+#define DDR_AD2  	DDRA
+#define PORT_AD2 	PORTA
+#define PIN_AD2  	PINA
+#define AD2_IDX  	2
+
+#define DDR_AD3  	DDRA
+#define PORT_AD3 	PORTA
+#define PIN_AD3  	PINA
+#define AD3_IDX  	3
+
+#define DDR_AD4  	DDRA
+#define PORT_AD4 	PORTA
+#define PIN_AD4  	PINA
+#define AD4_IDX  	4
+
+#define DDR_AD5  	DDRA
+#define PORT_AD5 	PORTA
+#define PIN_AD5  	PINA
+#define AD5_IDX  	5
+
+#define DDR_AD6  	DDRA
+#define PORT_AD6 	PORTA
+#define PIN_AD6  	PINA
+#define AD6_IDX  	6
+
+#define DDR_AD7  	DDRA
+#define PORT_AD7 	PORTA
+#define PIN_AD7  	PINA
+#define AD7_IDX  	7
+
+#define DDR_T0  	DDRB
+#define PORT_T0 	PORTB
+#define PIN_T0  	PINB
+#define T0_IDX  	0
+
+#define DDR_T1  	DDRB
+#define PORT_T1 	PORTB
+#define PIN_T1  	PINB
+#define T1_IDX  	1
+
+#define DDR_AIN0  	DDRB
+#define PORT_AIN0 	PORTB
+#define PIN_AIN0  	PINB
+#define AIN0_IDX  	2
+
+#define DDR_AIN1  	DDRB
+#define PORT_AIN1 	PORTB
+#define PIN_AIN1  	PINB
+#define AIN1_IDX  	3
+
+#define DDR_SS  	DDRB
+#define PORT_SS 	PORTB
+#define PIN_SS  	PINB
+#define SS_IDX  	4
+
+#define DDR_MOSI  	DDRB
+#define PORT_MOSI 	PORTB
+#define PIN_MOSI  	PINB
+#define MOSI_IDX  	5
+
+#define DDR_MISO  	DDRB
+#define PORT_MISO 	PORTB
+#define PIN_MISO  	PINB
+#define MISO_IDX  	6
+
+#define DDR_SCK  	DDRB
+#define PORT_SCK 	PORTB
+#define PIN_SCK  	PINB
+#define SCK_IDX  	7
+
+#define DDR_A8  	DDRC
+#define PORT_A8 	PORTC
+#define PIN_A8  	PINC
+#define A8_IDX  	0
+
+#define DDR_A9  	DDRC
+#define PORT_A9 	PORTC
+#define PIN_A9  	PINC
+#define A9_IDX  	1
+
+#define DDR_A10  	DDRC
+#define PORT_A10 	PORTC
+#define PIN_A10  	PINC
+#define A10_IDX  	2
+
+#define DDR_A11  	DDRC
+#define PORT_A11 	PORTC
+#define PIN_A11  	PINC
+#define A11_IDX  	3
+
+#define DDR_A12  	DDRC
+#define PORT_A12 	PORTC
+#define PIN_A12  	PINC
+#define A12_IDX  	4
+
+#define DDR_A13  	DDRC
+#define PORT_A13 	PORTC
+#define PIN_A13  	PINC
+#define A13_IDX  	5
+
+#define DDR_A14  	DDRC
+#define PORT_A14 	PORTC
+#define PIN_A14  	PINC
+#define A14_IDX  	6
+
+#define DDR_A15  	DDRC
+#define PORT_A15 	PORTC
+#define PIN_A15  	PINC
+#define A15_IDX  	7
+
+#define DDR_RXD  	DDRD
+#define PORT_RXD 	PORTD
+#define PIN_RXD  	PIND
+#define RXD_IDX  	0
+
+#define DDR_TXD  	DDRD
+#define PORT_TXD 	PORTD
+#define PIN_TXD  	PIND
+#define TXD_IDX  	1
+
+#define DDR_INT0  	DDRD
+#define PORT_INT0 	PORTD
+#define PIN_INT0  	PIND
+#define INT0_IDX  	2
+
+#define DDR_INT1  	DDRD
+#define PORT_INT1 	PORTD
+#define PIN_INT1  	PIND
+#define INT1_IDX  	3
+
+#define DDR_OC1A  	DDRD
+#define PORT_OC1A 	PORTD
+#define PIN_OC1A  	PIND
+#define OC1A_IDX  	5
+
+#define DDR_WR  	DDRD
+#define PORT_WR 	PORTD
+#define PIN_WR  	PIND
+#define WR_IDX  	6
+
+#define DDR_RD  	DDRD
+#define PORT_RD 	PORTD
+#define PIN_RD  	PIND
+#define RD_IDX  	7
+
+
 #endif /* _AVR_IO4414_H_ */
